
void abMain::init()
{
    QSettings settings;
    settings.setPath("Gemidjy.org", "aB Backup Tool", QSettings::User);
    
 log_path = settings.readEntry("/ab/files/pathLogs", QDir::homeDirPath()+"/Desktop/");
    
    statusBar()->message("Counting the number of the needed files...");
    this->move(240,150);
    form_4=new abSelect(this);
    forma=new abHelp(this);    
    proc_q = new QProcess(this);
    form7=new abOptions(this);
    form9=0;
    
    group_one=(QButtonGroup *) form_4->child("sys_set", "QButtonGroup");
    group_two=(QButtonGroup *) form_4->child("opt_set","QButtonGroup");
    group_thr=(QButtonGroup *) form_4->child("inc_set", "QButtonGroup");
    combo_one = (QComboBox *) form_4->child("comboBox1", "QComboBox");
    label = (QLineEdit *) form_4->child("tl_inc", "QLineEdit");
    
    connect(proc_q, SIGNAL(readyReadStderr()), this, SLOT(error()) );
    connect(proc_q, SIGNAL(processExited()), this, SLOT(proces_exit()) );
    
    cnt_root=new QProcess(this);
    cnt_root->addArgument("/usr/bin/.cnt_root");
    cnt_root->start();
    
    cnt=new QProcess(this);
    cnt->addArgument("/usr/bin/.cnt");
    cnt->start(); 
    
    exten="ab_BackUp_v0.1.tar.gz";
    ext="zcvf";
    type="GZip";
    ex_type="gz";
    form6=new abLogs(this);
    
    connect(cnt_root, SIGNAL(readyReadStdout()), this, SLOT(cnt_f()) );
    connect(cnt, SIGNAL(readyReadStdout()), this, SLOT(cnt_root_f()) );
    connect(cnt, SIGNAL(readyReadStdout()), this, SLOT(cnt_f()) );
    connect(cnt, SIGNAL(processExited()),this, SLOT(proc_exit()) );
    
    timerx=new QTimer(this);
    connect(timerx, SIGNAL(timeout()), this, SLOT(et()) );
    
    num_temp="[Not available]";
}

void abMain::et()
{
    int s = lcd3->intValue();
    int m = lcd2->intValue();
    int c = lcd1->intValue();
    
    lcd3->display(++s);
    
    if(s>59) {
	lcd2->display(++m);
	lcd3->display(0);
    }
    
    if(m>59) {
	lcd1->display(++c);
	lcd2->display(0);
    }
}

void abMain::pref_w()
{
    form6->show();
}

void abMain::prefe()
{
    form7->show();
}

void abMain::activated_2(int i)
{    
    switch(i){
    case 0:
	sys_what="/etc";	
	group_one->setEnabled(true);
	group_two->setEnabled(false);
	group_thr->setEnabled(false);
	form_4->show();
	break;
    case 2:
	sys_what=QDir::homeDirPath();
	group_two->setEnabled(true);
	group_one->setEnabled(false);
	group_thr->setEnabled(false);
	form_4->show();
	break;
    }
}

void abMain::activated_3(int i)
{
    switch(i){
    case 0:
	comboBox3->setEnabled(true);
	toolb_a->setEnabled(true);
	label_a->setEnabled(true);
	dir=label_a->text();
	switch(comboBox3->currentItem()) {
	case 0:
	    ext="zcvf";
	    break;
	case 1:
	    ext="jcvf";
	    break;
	}
	break;
    case 1:
	comboBox3->setEnabled(false);
	toolb_a->setEnabled(false);
	label_a->setEnabled(false);
	ext="uvf";
	dir=QString::null;	    
	group_one->setEnabled(false);
	group_two->setEnabled(false);
	group_thr->setEnabled(true);
	form_4->show();
	break;
    }
}

void abMain::error()
{
    textEdit1_2->append(proc_q->readStderr());
    if(ch_err->isChecked()) create_error_log();
}

void abMain::create_error_log()
{
    QDate date = QDate::currentDate();
    s = s.sprintf("%d.%d.%d", date.day(), date.month(), date.year());
    
    QString read_log(textEdit1_2->text());    
    QFile file(log_path+"ERROR-"+s);
    if(file.open( IO_WriteOnly | IO_Append ))
    {
	QTextStream str( &file );    	    
	str<<read_log;   
    }		   
    file.close();
}

void abMain::proc_exit()
{
    statusBar()->message("Ready to proceed...", 15000);
}

void abMain::cnt_root_f()
{  
    temp_root_e=cnt_root->readLineStdout();
    temp_root_i=temp_root_e.toInt();    
    if(!temp_root_e.isEmpty()) prim_d=temp_root_i/2;
       else prim_d=1000;
}    

void abMain::cnt_f()
{
    temp_e=cnt->readLineStdout();
    temp_d=temp_e.toInt(); 
    if(!temp_e.isEmpty()) prim=temp_d/2;	
         else prim=5500;
}

void abMain::chQ(bool b)
{
    if(b)
    {	
	type="Bzip2";
	ex_type="bz2";
	exten="ab_BackUp_v0.1.tar.bz2";
	ext="jcvf";
	bt_gr1->setEnabled(true);
	bt_gr2->setEnabled(false);
	ch_boxA->setChecked(false);
	pb_finish->setEnabled(true);
    }
    else
    {
	bt_gr1->setEnabled(false);
	ch_log->setChecked(false);
	ch_err->setChecked(false);
	ch_rprt->setChecked(false);
	pb_finish->setEnabled(false);
    }
}	

void abMain::chA(bool b)
{
    if(b)
    {
	type="Gzip";
	ex_type="gz";
	exten="ab_BackUp_v0.1.tar.gz";
	ext="zcvf";
	bt_gr2->setEnabled(true);	
	bt_gr1->setEnabled(false);
	ch_boxQ->setChecked(false);
	pb_finish->setEnabled(true);
    }
    else
    {
	bt_gr2->setEnabled(false);
	ch_log->setChecked(false);
	ch_err->setChecked(false);
	ch_rprt->setChecked(false);
	pb_finish->setEnabled(false);
    }
    
}

void abMain::closeEvent(QCloseEvent *e)
{     
    QMessageBox mb("Warning", "Are you sure you want to exit?",
		   QMessageBox::Warning,
		   QMessageBox::Yes | QMessageBox::Escape,
		   QMessageBox::No | QMessageBox::Default, 0);
    
    switch(mb.exec())
    {
    case QMessageBox::Yes:
	e->accept();
	break;
    case QMessageBox::No:
	e->ignore();
	break;
    }
}

void abMain::help_f()
{
    forma->show();
}

void abMain::where_safe_f()
{
    dir = QFileDialog::getExistingDirectory(QDir::homeDirPath(), this, "Select Directory", "Selection",true, true);
    num_temp=dir;
    label_q->setText(dir);    
}

void abMain::where_safe_fA()
{
    dir = QFileDialog::getExistingDirectory(QDir::homeDirPath(),this,"Select Directory","Selection",true,true);
    num_temp=dir;
    label_a->setText(dir);
}

void abMain::activation(int i)
{    
    switch(i)
    {
    case 0:
	dir=label_a->text();
	exten="ab_BackUp_v0.1.tar.gz";
	ext="zcvf";
	type="GZip";
	ex_type="gz";
	break;
    case 1:
	dir=label_a->text();	
	exten="ab_BackUp_v0.1.tar.bz2";
	ext="jcvf";
	type="Bzip2";
	ex_type="bz2";
	break;
    }
}

void abMain::start_backup()
{ 
    timerx->start(1000);
    QString check_label(label->text());    
     
    if(ch_boxA->isChecked()) 
    {
	switch(comb_ar->currentItem())   {
	case 1:
	    if(!check_label.isEmpty()) {
		exten=label->text(); }
	    else { 
		QMessageBox::information(this, "Warning - Empty Selection", "You didn't choose archive that is needed\nfor incremental backup. Try again.");
		return;
	    }
	    break;
	}

	proc_q->addArgument("tar");
	proc_q->addArgument(ext);
	proc_q->addArgument(dir+exten);
	
	switch(cmb_typ->currentItem())
	{
    case 0:
	switch(combo_one->currentItem()) {
	case 0:
	    num_files=10;
	    progrres->setTotalSteps(10);
	    sys_what="/boot";
	    proc_q->addArgument(sys_what);
	    break;
	case 1:
	    num_files=prim_d*2;
	    progrres->setTotalSteps(prim_d);
	    sys_what="/etc";
	    proc_q->addArgument(sys_what);
	    break;
	}
	break;
    case 1:
	progrres->setTotalSteps(prim);
	num_files=prim;
	sys_what = QDir::homeDirPath();
	proc_q->addArgument(sys_what);	
	break;
    case 2:
	stringovi=form_4->strlst;
	if(!stringovi.isEmpty())
	{
	progrres->setTotalSteps(547);
	num_files=547;
	for(QStringList::Iterator it = stringovi.begin();it!=stringovi.end();++it) {
	    string_dva=*it;
	    proc_q->addArgument(string_dva);
              }
    } else  {
	QMessageBox::warning(this, "Warning", "Empty optional directories. Try again.");
	return;
    }
	break;	
          }
    }
    
    if(ch_boxQ->isChecked())
    {
	proc_q->addArgument("tar");
	proc_q->addArgument(ext);
	proc_q->addArgument(dir+exten);
	
	switch(cmb_ty->currentItem()) {
	case 0:
	    progrres->setTotalSteps(prim_d);
	    num_files=prim_d*2;
	    sys_what="/etc";
	    proc_q->addArgument(sys_what);
	    break;
	case 1:
	    progrres->setTotalSteps(prim);
	    num_files=prim;
	    sys_what=QDir::homeDirPath();
	    proc_q->addArgument(sys_what);
	    break;
	}
    }      
       
    proc_q->start();
    connect(proc_q, SIGNAL(readyReadStdout()), this, SLOT(readFromOut()) );
    
    if(ch_log->isChecked() || ch_err->isChecked()) data_time_logs();    
    if(ch_rprt->isChecked()) create_report();
    
    tabWidget2->setCurrentPage(2);
    pb_finish->setEnabled(false);
    pb_new->setEnabled(true);   
}

void abMain::proces_exit()
{    
   bzip2_f();
    progrres->setProgress(progrres->totalSteps());   
    timerx->stop();
    pb_new->setEnabled(false);
    
    if(rd_off->isChecked()) reboot_f();    
    if(rd_halt->isChecked()) halt_f();

    after_questions();
}

void abMain::bzip2_f()
{
    QProcess *bzip = new QProcess(this);
    bzip->addArgument("bzip2");
    bzip->addArgument(exten);
    bzip->start();   
}

void abMain::destroy()
{
    delete proc_q;
    delete cnt;
    delete cnt_root;    
    delete timerx;
}

void abMain::reboot_f()
{
    QProcess *proc_rbt=new QProcess(this);
    proc_rbt->addArgument("reboot");
    proc_rbt->start();
}

void abMain::halt_f()
{
    QProcess *proc_hlt=new QProcess(this);
    proc_hlt->addArgument("halt");
    proc_hlt->addArgument("-p");
    proc_hlt->start();
}

void abMain::stop_f()
{    
    QMessageBox mb("Warning", "Are you sure you want to terminate\the current progress?",
		   QMessageBox::Warning,
		   QMessageBox::Yes | QMessageBox::Escape,
		   QMessageBox::No | QMessageBox::Default, 0);
    
    switch(mb.exec())
    {
    case QMessageBox::Yes:
	ch_boxQ->setChecked(false);
	ch_boxA->setChecked(false);
	pb_new->setDisabled(true);
	pb_finish->setDisabled(true);
	proc_q->kill();
	progrres->reset();
	break;
    case QMessageBox::No:
	return;
	break;
    }
}

void abMain::readFromOut()
{
    textEdit1->append(proc_q->readStdout());
    if(ch_log->isChecked()) create_log();
    
    QDate date = QDate::currentDate();
    QString s = s.sprintf("%d.%d.%d", date.day(), date.month(), date.year());
    
    int prog(progrres->progress());
    progrres->setProgress(++prog);
}  
    
void abMain::create_log()
{
    QString read_log(textEdit1->text());    
    QFile file(log_path+"LOG-"+s);
    
    if(file.open( IO_WriteOnly | IO_Append ))
    {
	QTextStream str( &file );    	
	str<<read_log;
	str<<QString::null;
    }
    file.close();     
} 


void abMain::spec_date(bool b)
{
    if(b)
    {
	date_lb->setEnabled(true);
	time_lb->setEnabled(true);
	date_ed->setEnabled(true);
	time_ed->setEnabled(true);
	ev_day->setEnabled(false);
	ev_sun->setEnabled(false);
	daily_sc->setChecked(false);
	ev_day->setChecked(false);
	ev_sun->setChecked(false);
    }
    else
    {
	date_lb->setEnabled(true);
	time_lb->setEnabled(true);
	date_ed->setEnabled(true);
	time_ed->setEnabled(true);
    }
}

void abMain::daily_sch(bool b)
{
    if(b)
    {
	ev_sun->setEnabled(true);
	ev_sun->setChecked(false);
	ev_day->setEnabled(true);
	ev_day->setChecked(false);
	date_lb->setEnabled(false);
	time_lb->setEnabled(false);
	date_ed->setEnabled(false);
	time_ed->setEnabled(false);
    }
    else
    {
	ev_day->setChecked(false);
	ev_sun->setChecked(false);
	ev_day->setEnabled(false);
	ev_sun->setEnabled(false);
    }
}

void abMain::cancel_sch()
{
    sp_date->setChecked(false);
    daily_sc->setChecked(false);
    date_lb->setEnabled(false);
    time_lb->setEnabled(false);
    date_ed->setEnabled(false);
    time_ed->setEnabled(false);
}

void abMain::create_report()
{ 
    QTime time_t(QTime::currentTime());
    QString time(time_t.toString());
    QDate date_t(QDate::currentDate());
    QString date(date_t.toString());
    QFile file(log_path+"REPORT");
    QTextStream str( &file );
    if(file.open( IO_WriteOnly | IO_Append )) {
    str<<endl<<" Date of the begining: "<<date<<endl<<" Time when the process begun: "<<time<<endl<<" Number of BackUpped files: "<<num_files<<endl<<" Location on disk: "<<num_temp<<endl<<" Name of the archive: "<<exten<<endl<<" Using "<<type<<" archive type. "<<endl<<" ___________________aB Backup Report_____________________ "<<endl<<endl;
    str.unsetDevice();
   }
    file.close();     
}

void abMain::data_time_logs()
{
    QDate date_d = QDate::currentDate();
    s = s.sprintf("%d.%d.%d", date_d.day(), date_d.month(), date_d.year());
    
    QDate dt = QDate::currentDate();
    QString date = dt.toString();
    QTime tm = QTime::currentTime();
    QString time = tm.toString();
    
    QFile file(log_path+"LOG-"+s);
    QFile file_dva(log_path+"ERROR-"+s);
    QTextStream str_dva(&file_dva);
    QTextStream str(&file);
    
    if(file.open(IO_WriteOnly | IO_Append) && file_dva.open(IO_WriteOnly | IO_Append)) {
	str<<endl<<"______________________________________________________________________________________________"<<endl<<" The next lines are from: "<<date<<" and the process log was created at "<<time<<endl<<"______________________________________________________________________________________________"<<endl<<endl;
	
	str_dva<<endl<<"______________________________________________________________________________________________"<<endl<<" The next lines are from "<<date<<" and the error log was created at "<<time<<endl<<"______________________________________________________________________________________________"<<endl<<endl; 	
	str.unsetDevice();
	str_dva.unsetDevice();
    } 
    file.close(); 
    file_dva.close();
}

void abMain::about_author()
{
    QMessageBox::about(this, "About the author", "The author of this project is Aleksandar Balalovski,\npart of the GSS Team.\n\nHe is on the 'Applied Computer Science' college\nin his town and he's second year now.\nHe is big Linux fan and great fighter for free/open\nsoftware.\n\nYou can contact him on gemidjy@freemail.org.mk,\nor by GSM: +38970623271.\n\nBest regards..");
}

void abMain::about_qt()
{
    QMessageBox::aboutQt(this, "aB About Qt");
}

void abMain::restor_session()
{
    if(form9==0) form9 = new abRestor();
    form9->show();
}

void abMain::new_session()
{
    init();
    lcd3->display(0);
    lcd2->display(0);	
    lcd1->display(0);	
    comb_ar->setCurrentItem(0);
    comboBox3->setCurrentItem(0);
    cmb_typ->setCurrentItem(1);
    ch_boxQ->setChecked(false);
    label_q->clear();
    label_a->clear();	
    ch_boxA->setChecked(false);
    pb_new->setDisabled(true);
    pb_finish->setDisabled(true);
    textEdit1->clear();
    textEdit1_2->clear();
    progrres->reset();
    pb_finish->setEnabled(false);   
    pb_new->setEnabled(false);    
    comboBox3->setEnabled(true);
    toolb_a->setEnabled(true);
    label_a->setEnabled(true);
    ch_err->setChecked(false);
    ch_log->setChecked(false);
    ch_rprt->setChecked(false);
    rd_off->setChecked(false);
    rd_halt->setChecked(false);
    tabWidget2->setCurrentPage(0);
    QMessageBox::information(this, "New session begun", "The new Backup session begun.\nAll previous settings are not available now.");
}

void abMain::after_questions()
{
    QMessageBox msg_box("Process Finished", "The BackUp process has finished.\n\nIf there were some problems while processing, \nplease send a report to gemidjy@freemail.org.mk.\n\nWhat do you want to do?",
		   QMessageBox::Information,
		   QMessageBox::Yes | QMessageBox::Default,
		   QMessageBox::No | QMessageBox::Escape, 
		   QMessageBox::Cancel);
    
    msg_box.setButtonText(QMessageBox::Yes, "New Session");
    msg_box.setButtonText(QMessageBox::No, "Return to program");    
    msg_box.setButtonText(QMessageBox::Cancel, "Exit");    
    
    
    switch(msg_box.exec())
    {
    case QMessageBox::Yes:
	new_session();
	break;
    case QMessageBox::No:
	return;
	break;
    case QMessageBox::Cancel:
	abMain::close();
	break;
    }
}

